
package de.ivu.elect.presentation.system.menu;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.business.konfiguration.control.SystemGebietsebeneAuswahl;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.system.SystemGebietsebeneEditView;

public class SystemGebietsebeneEditMenuItem extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient SystemGebietsebeneAuswahl systemGebietsebeneAuswahl;

  public SystemGebietsebeneEditMenuItem() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.KONFIGURATION_EDIT) && getMandant().getArt().isCustomerMandant();
  }

  @Override
  protected boolean isDisabledInternal() {
    return getMandant().getSystemGebietsebene().isGesetzt() && systemGebietsebeneAuswahl.getAvailableSystemGebietsebenen().size() < 2;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return AbstractGebietSecurity.KEINE_GEBIET_SECURITY;
  }

  @Nullable
  @Override
  public String getTargetViewId() {
    return SystemGebietsebeneEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "system.gebietsebene.menu.item";
  }

  @Override
  public String getIcon() {
    return "fa fa-sitemap";
  }
}
